#ifndef _TARGA_IMAGE_H_
#define _TARGA_IMAGE_H_

#include <Fl/Fl.h>
#include <Fl/Fl_Widget.h>
#include <stdio.h>

class TargaImage {
    public:
    	// Constructors
	TargaImage(void) { width = 0, height = 0, data = NULL; };
	TargaImage(int, int, unsigned char*);

	// Destructor
	~TargaImage(void) { delete[] data; };

	// Public member variables
	int		width;	// The width of the image
	int		height;	// The height of the image
	unsigned char	*data;	// The pixel data for the image, assumed to be
	                        // in pre-multiplied RGBA format.

	// Public functions
	int	        Save_Image(char*); // Save the image to a file
	unsigned char*	To_RGB(void);	// Convert the image to RGB format,
	                                // returning the pixels.

	TargaImage*	Alpha_Image(void);

	static TargaImage*   Load_Image(char*);
		// Load a file and return a pointer to a new TargaImage object.
		// Returns NULL on failure

    private:
	TargaImage* Reverse_Rows(void);
		// Copies the image into another, reversing the rows as it goes.
	                                                
};


#endif
